// QuickTimeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestOcx.h"
#include "QuickTimeDlg.h"
#include "resource.h"


IMPLEMENT_DYNAMIC(CQuickTimeDlg, CDialog)

CQuickTimeDlg::CQuickTimeDlg(const CString& strURL, BOOL bFullscreen, BOOL bMovieControllerVisible, CWnd* pParent /*=NULL*/)
        : CDialog(CQuickTimeDlg::IDD, pParent)
        , m_strURL(strURL)
        , m_bFullscreen(bFullscreen)
        , m_bMovieControllerVisible(bMovieControllerVisible)
        , m_kQtControl(this)
{

}

CQuickTimeDlg::~CQuickTimeDlg()
{
}

void CQuickTimeDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        DDX_Control(pDX, IDC_QTCONTROL, m_kQtControl);
}


BEGIN_MESSAGE_MAP(CQuickTimeDlg, CDialog)
        ON_MESSAGE(WM_SET_FULLSCREEN, OnSetFullscreen)
        ON_WM_SHOWWINDOW()
        ON_WM_CLOSE()
END_MESSAGE_MAP()


BOOL CQuickTimeDlg::OnInitDialog()
{
        CDialog::OnInitDialog();

        HICON hIcon = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICON_QUICKTIME));
        SetIcon(hIcon, FALSE);

        m_kQtControl.put_FileName(m_strURL);
        m_kQtControl.put_FullScreen(m_bFullscreen);
        m_kQtControl.put_MovieControllerVisible(m_bMovieControllerVisible);

        return TRUE;  // return TRUE unless you set the focus to a control
        // ECCEZIONE: le pagine delle propriet? OCX devono restituire FALSE
}

void CQuickTimeDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
        // When fullscreen is true, I hide myself.
        // I need this because when the QuickTime control goes fullscreen, it
        // is drawn behind me, but I want it to be in the foreground.
        if(bShow && m_bFullscreen)
        {
                PostMessage(WM_SHOWWINDOW, FALSE, SW_OTHERZOOM);
        }
        else
        {
                CDialog::OnShowWindow(bShow, nStatus);
        }
}

LRESULT CQuickTimeDlg::OnSetFullscreen(WPARAM bFullscreen, LPARAM /*unused*/)
{
        m_bFullscreen = (BOOL)bFullscreen;
        return 0;
}


void CQuickTimeDlg::OnClose()
{
        // This error is thrown:
        //
//Windows has triggered a breakpoint in TestOcx.exe.
//
//This may be due to a corruption of the heap, which indicates a bug in TestOcx.exe or any of the DLLs it has loaded.
//
//This may also be due to the user pressing F12 while TestOcx.exe has focus.
//
//The output window may have more diagnostic information.
//
//If I comment it, 5 assert are thrown, but then it seems to work.

        CDialog::OnClose();
}
